#!/usr/bin/perl -w
# Autor: Kamil Behun
# skript urceny k vytvoreniu adresarovej struktury s prislusnymi priznakmi podla parametrov a Datasetu
# pesniciek vo formate mp3,wav alebo au

#######################################################################################################
# inicializacia globalnych premennych reprezentujicich vyskyt urcitych parametrov v prikazovom riadku #
#######################################################################################################
sub valueInit {
  $hlp = 0; $mfcc = 0; $filterbank = 0; $in = 0; $out_m = 0; $out_f = 0; $conf_m = 0; $conf_f =0; $smpl = 0; $format_i = 0;
  $inAddr = ""; $outAddr_m = ""; $outAddr_f = ""; $conFile_m = ""; $conFile_f = ""; $in_format = ""; $sample = 0;
}

##############################################################################
# naplnenie premennych urcijucich vyskyt urciteho parametu prikazoveho radku #
# funkcia sluzi na rozparsovanie prikazoveho riadka                          #
##############################################################################
sub argvLoader {
  my $param = "";
  my $pouzitie = 0;
  my $j = 0;
  if (!defined @ARGV) {
     return 1;
  }
  for ($j = 0; $j <= $#ARGV; $j++) {
      $param = $ARGV[$j];
      #rocleneni a spocteni parametru
      SWITCH: {
            $param =~ /^-h$/o                     && do { $hlp++;
                                                   $pouzitie = 1;
                                                   last SWITCH; }; 
            $param =~ /^-mfcc$/o                  && do { $mfcc++;
                                                   $pouzitie = 1;
                                                   last SWITCH; };
            $param =~ /^-filterbank$/o            && do { $filterbank++;
                                                   $pouzitie = 1;
                                                   last SWITCH; };
            $param =~ /^--format=(.*)$/o    && do { $format_i++;
                                                   $in_format = $1;
                                                   $pouzitie = 1; 
                                                   last SWITCH; };
            $param =~ /^--sample=(.*)$/o    && do { $smpl++;
                                                   $sample = $1;
                                                   $pouzitie = 1; 
                                                   last SWITCH; };
            $param =~ /^--configFile_m=(.*)$/o    && do { $conf_m++;
                                                   $conFile_m = $1;
                                                   $pouzitie = 1; 
                                                   last SWITCH; };
            $param =~ /^--configFile_f=(.*)$/o    && do { $conf_f++;
                                                   $conFile_f = $1;
                                                   $pouzitie = 1;
                                                   last SWITCH; };
            $param =~ /^--inputAddr=(.*)$/o       && do { $in++;
                                                   $inAddr = $1;
                                                   $pouzitie = 1;
                                                   last SWITCH; };
            $param =~ /^--outputAddr_m=(.*)$/o    && do { $out_m++;
                                                   $outAddr_m = $1;
                                                   $pouzitie = 1;
                                                   last SWITCH; };
            $param =~ /^--outputAddr_f=(.*)$/o    && do { $out_f++;
                                                   $outAddr_f = $1;
                                                   $pouzitie = 1;
                                                   last SWITCH; };
      }
      if ($pouzitie != 1) {
          return 0;
      }
      else {
      }
      $pouzitie = 0;
  }
  return 1;
}

######################################################################
# overenie spravnej syntaxie parametrov prikazoveho riadka           #
# nie kazdy parameter sa moze pouzit v kombinacii s inym             #
# tato funkcia overuje aj ci nedoslo k nasobnemu pouzitiu parametrov #
# vystupom je 0 pri chybe alebo 1 pri spravnom kontexte parametrov   # 
######################################################################
sub argvControler {
  if ($hlp != 0) {
     if ($hlp != 1) {
        return 0;
     }
     if (($in != 0) || ($out_m != 0) || ($conf_m != 0) || ($out_f != 0) || ($conf_f != 0) || ($mfcc != 0) || ($filterbank != 0) || ($sample != 0)
         || ($format_i != 0)) {
        return 0;
     }
     else {
        return 1;
     }
  }
  if ($format_i != 0) {
     if ($format_i != 1) {
	return 0;
     }
     if (!($in_format =~ /^mp3$/o || $in_format =~ /^wav$/o || $in_format =~ /^au$/o)) {
	return 0;
     }
  }
  else {
     $in_format = "mp3";
  }

  if ($mfcc != 0) {
     if ($mfcc != 1) {
        return 0;
     }
  }
  if ($smpl != 0) {
     if ($smpl != 1) {
        return 0;
     }
  }
  if ($filterbank != 0) {
     if ($filterbank != 1) {
        return 0;
     }
  }
  if ($filterbank == 0 && $mfcc == 0) {
     return 0;
  }
  if ($conf_m != 0) {
     if ($conf_m != 1) {
        return 0;
     }
  }
  else {
     $conFile_m = "config_mfcc";
  }
  if ($conf_f != 0) {
     if ($conf_f != 1) {
        return 0;
     }
  }
  else {
     $conFile_f = "config_filterbank";
  }
  if ($in != 0) {
     if ($in != 1) {
        return 0;
     }
  }
  else {
     $inAddr = "DataSet";
  }
  if ($out_m != 0) {
     if ($out_m != 1) {
        return 0;
     }
  }
  else {
     $outAddr_m = "Mfcc";
  }
  if ($out_f != 0) {
     if ($out_f != 1) {
        return 0;
     }
  }
  else {
     $outAddr_f = "FilterBank";
  }
  
  return 1;
}

###########################
sub vypisParam {
  
  print "mfcc = " . $mfcc . "\n";
  print "filterbank = " . $filterbank . "\n";
  print "inAddr = " . $in ." ". $inAddr ."\n";
  print "outAddr_m = " . $out_m ." ". $outAddr_m ."\n";
  print "outAddr_f = " . $out_f ." ". $outAddr_f ."\n";
  print "conFile_m = " . $conf_m ." ". $conFile_m ."\n";
  print "conFile_f = " . $conf_f ." ". $conFile_f ."\n";
  print "sample = " . $smpl . " ". $sample ."\n";
  print "format = " . $format_i . " " . $in_format . "\n";
}


##############################################################################################################
# funkcia na prevod mp3 alebo au pesniciek na wav (mpg123, sox) z tychto wav nahraviek s vyuzitim HCopy      #
# (HTK Toolkit) extrahuje prislusne priznaky podla vstupnych parametrov                                      #
# podla parametrov tiez moze pred extrahovanim priznakov prevzorkovat nahravku na zadanu frekvenciu (sox)    #
# vystupom je podobna adresarova struktura ako struktura vstupna, s tym rozdielom,                           #
# ze namiseto mp3,au alebo wav suborov vo vstupnom adresari existuje prislusny subor priznakov vo vystupnom  #
##############################################################################################################
sub rozclenAdresar {

    my($dir,$out_dir_m,$out_dir_f) = @_;

    my $fh;
    my $adresa = "";
    my $vys_m = "";
    my $vys_f = "";
    my $wav_subor = "";
    my $mfcc_subor = "";
    my $filterbank_subor = "";
    my $hlp_mfcc = "";
    my $hlp_filterbank = "";
    my $vtupny_subor = "";
    my $clean = "";
    my $sample_wav = "";

    opendir($fh, $dir) or die "Nepodarilo sa otevrit $dir: $!";

    while (my $pol = readdir $fh){
        next if $pol eq "." or $pol eq "..";

        $adresa = $dir . "/" . $pol;
        if (-f $adresa){
            if (($pol =~ /.*\.mp3$/o && $in_format =~ /^mp3$/o) || ($pol =~ /.*\.wav$/o && $in_format =~ /^wav$/o)
                || ($pol =~ /.*\.au$/o && $in_format =~ /^au$/o)) {

                $vtupny_subor = $adresa;
		$vtupny_subor =~ s/([\~\!\@\#\$\%\^\&\*\(\)\{\}\[\]\"\'\`])/\\$1/g;
                $vtupny_subor =~ s/ /\\ /g;
		$clean = $adresa;
		$clean =~ s/([\~\!\@\#\$\%\^\&\*\(\)\{\}\[\]\"\'\`])//g;
                $wav_subor = $clean;
                $wav_subor =~ s/ //g;
                $hlp_mfcc = $clean;
                $hlp_mfcc =~ s/ //g;
                $hlp_filterbank = $clean;
                $hlp_filterbank =~ s/ //g;
                $mfcc_subor = $clean;
                $mfcc_subor =~ s/$dir/$out_dir_m/;
                $mfcc_subor =~ s/ //g;
                $filterbank_subor = $clean;
                $filterbank_subor =~ s/$dir/$out_dir_f/;
                $filterbank_subor =~ s/ //g;

                if ($in_format =~ /^mp3$/o) {
                   $wav_subor =~ s/\.mp3/.wav/;
                   $hlp_mfcc =~ s/\.mp3/.mfc/;
                   $hlp_filterbank =~ s/\.mp3/.flt/;
                   $mfcc_subor =~ s/\.mp3/.mfc/;
                   $filterbank_subor =~ s/\.mp3/.flt/;
                }

                if ($in_format =~ /^au$/o) {
                   $wav_subor =~ s/\.au/.wav/;
                   $hlp_mfcc =~ s/\.au/.mfc/;
                   $hlp_filterbank =~ s/\.au/.flt/;
                   $mfcc_subor =~ s/\.au/.mfc/;
                   $filterbank_subor =~ s/\.au/.flt/;
                }

                if ($in_format =~ /^wav$/o) {
                   $hlp_mfcc =~ s/\.wav/.mfc/;
                   $hlp_filterbank =~ s/\.wav/.flt/;
                   $mfcc_subor =~ s/\.wav/.mfc/;
                   $filterbank_subor =~ s/\.wav/.flt/;
                }

                if ($in_format =~ /^mp3$/o) {
                   if ((system "mpg123 -w " . $wav_subor . " " . $vtupny_subor) != 0) {
                       die "nepodarilo sa skonvertvat pesnicku: " . $vtupny_subor . "\n";
                   }
                }
                else {
                   if ((system "sox ". $vtupny_subor . " " . $wav_subor) != 0) {
                      die "nepodarilo sa skonvertovat pesnicku" . $vtupny_subor . "\n";
                   }
                }

                if ($smpl) {
                   $sample_wav = $wav_subor;
                   $sample_wav =~ s/\.wav$/_$sample/;
                   $sample_wav .= ".wav";
                   if ((system "sox ". $wav_subor ." -r ". $sample ." ". $sample_wav) != 0) {
                      die "nepodarilo sa presamplovat subor: ". $wav_subor ." na frekveciu: ". $sample ."\n";
                   }
                   if (!($in_format =~ /^wav$/o)) {
                      unlink $wav_subor;
                   }
                   $wav_subor = $sample_wav;
                }

                if ($mfcc) {
                    if ((system "HCopy -T 1 -C " . $conFile_m . " " . $wav_subor . " " . $hlp_mfcc) != 0) {
                        if (!($in_format =~ /^wav$/o) || $smpl) {
                           unlink $wav_subor;
                        }
                        die "nepodarilo sa pomocou HCopy vytvorit MFCC pre subor: " . $vtupny_subor . "\n";
                    }
                }

                if ($filterbank) {
                    if ((system "HCopy -T 1 -C " . $conFile_f . " " . $wav_subor . " " . $hlp_filterbank) != 0) {
                        if (!($in_format =~ /^wav$/o) || $smpl) {
                           unlink $wav_subor;
                        }
                        die "nepodarilo sa pomocou HCopy vytvorit filterbank mel koeficienty pre subor: " . $vtupny_subor . "\n";
                    }
                }

                if (!($in_format =~ /^wav$/o) || $smpl) {
                   unlink $wav_subor;
                }

                if ($mfcc) {
                    if ((system "HList -r " . $hlp_mfcc . " > " . $mfcc_subor) != 0) {
                        unlink $hlp_mfcc;
                        die "nepodarilo sa pomocou HList vytvorit textovu formu MFCC pre subor: " . $vtupny_subor . "\n";
                    }
                    unlink $hlp_mfcc;
                }

                if ($filterbank) {
                    if ((system "HList -r " . $hlp_filterbank . " > " . $filterbank_subor) != 0) {
                        unlink $hlp_filterbank;
                        die "nepodarilo sa pomocou HList vytvorit textovu formu filterbank mel koeficientov pre subor: " . $vtupny_subor . "\n";
                    }
                    unlink $hlp_filterbank;
                }

            }
        } elsif(-d $adresa){
            $vys_m = $out_dir_m . "/" . $pol;
            $vys_f = $out_dir_f . "/" . $pol;
            if ($mfcc) {
                mkdir $vys_m,0777;
            }
            if ($filterbank) {
                mkdir $vys_f,0777;
            }
            &rozclenAdresar($adresa,$vys_m,$vys_f);  #rekurzia
        }
    }
}


################## zaciatok skriptu ########################

$napoveda =
"Skript htk_skript.pl - extrahuje priznaky zo vstupnych suborov
Autor: Kamil Behun
Pouzivane nastroje: mpg123, sox a HTK (HCopy a HList)
- tento skript vznikom pre ucel bakalarskej prace

Tento skript je urcny k extrahovani priznakov podla vstupnych parametor zo vtuspnej
adresarovej struktury, v ktorej sa nachadzaju podla zanru usporiadane v prislusnych
adresaroch pesnicky vo formate mp3, au alebo wav. V tomto adresari sa htk_skript.pl
rekurzivne zanoruje a tieto pesnicky vyhladava. Pesnicky su v pripade ak su
vo formate au alebo mp3 do do wav formatu s vyuzitim utilit mpg123 (mp3) a sox (au).

Tieto wav nahravky ak bolo v priade poziadavku pre extrakciou priznakov htk_skript.pl
prevzorkuje na prislusnu vzorkovaciu frekvenciu pomocou nastroja sox

Z wav formatu sa dalej extrahuju zadane priznaky pomocou HTK nastroja HCopy a tieto
priznaky sa dalej prevadzaju do textoveho formatu pomocou HTK nastroja HList.

Vystupom tohto skriptu je obdobna adresarova struktura ku vstupnej adresarovej
strukture s odpovedajucimi subormi priynakovzch vektorov.

Skript je mozne spustat s nasledujucimi parametrami:

    -h                   Napoveda

    --format=nazov       Urcuje v akom formate sa nachadzaju nahravky vo vstupnej
                         adresarovej strukture. hkt_skript.pl zvlada nasledujuce
                         formaty: mp3, wav, au

    -mfcc                Nastavuje, ze sa budu extrahovat Mfcc z nahraviek.
                         Suvisiace parametre: inptuAddr, outputAddr_m, configFile_m.

    -filterbank          Nastavuje, ze sa budu extrahovat Mel energie spektra za pomoci
                         filterbaniek z nahravky.
                         Suvisiace keficienty: inputAddr, outputAddr_f, configFile_f.

    --inputAddr=meno     Tento parameter urcuje meno vstupneho adresarovej struktury,
                         ktora obsahuje pesnicky v zaradene do prislusnych zanrov
                         (adresarov) a z ktorej sa budu extrahovat priznaky.
                         Defaultne meno je \"DataSet\".

    --outputAddr_m=meno  Tento parameter urcuje meno vystupneho adresara,kde budu
                         subory s MFCC vektormi ulozene.
                         Defaultne meno je \"Mfcc\".

    --outputAddr_f=meno  Tento parameter urcuje meno vystupneho adresara,kde budu
                         subory s vektormi Mel energii spektra ulozene.
                         Defaultne meno je \"FilterBank\".

    --configFile_m=meno  Tento paramener urcuje meno konfiguracneho suboru,
                         ktory sa ma pouzit pri utilite HCopy pri parametri -C.
                         Defaultne meno je config_mfcc.

    --configFile_f=meno  Tento paramener urcuje meno konfiguracneho suboru,
                         ktory sa ma pouzit pri utilite HCopy pri parametri -C.
                         Defaultne meno je config_filterbank.

    --sample=frekvencia  Nastavuje frekveciu, na ktoru sa ma pred vypoctom pesnicka
                         prevzorkovat. Vyuziava sa utilita sox. parameter je v Hz.
    
";

&valueInit();

if (&argvLoader() == 0) {
    die "zle zadane parametre prikazoveho riadku\n"
}

if (&argvControler() == 0) {
    die "zle zadane parametre prikazoveho riadku, nasobne alebo nepovolene kombinacie paramatrov\n";
}

if ($hlp == 1) {
   print $napoveda;
} else {
   if ($mfcc) {
      mkdir $outAddr_m,0777;
   }
   if ($filterbank) {
      mkdir $outAddr_f,0777;
   }
   &vypisParam();
   &rozclenAdresar($inAddr,$outAddr_m,$outAddr_f);
   print "vsetko prebehlo OK\n";
}
