/* 
 * autor: Kamil Behun
 * email: xbehun03@stud.fit.vutbr.cz 
 * popis: trieda MelEn_transform
 *        je urcena k vytvoreniu PGM formatu pre obrazok zo zadaneho vstupneho suboru
 *   
 */

#ifndef _MELEN_TRANSFORM_H_
#define _MELEN_TRANSFORM_H_

#include <iostream>
#include <fstream>
#include <limits>

using namespace std;

class MelEn_transform {

    protected:
        double max_log_val;       // maximalna hodnota logaritmu Mel energie v subore
        int coef;                 // pocet Mel energii v jednom vektore v subore
        int max_output_val;       // maximalna hodnota vo vystupnom subore, ktoru chceme povolit (urcuje pocet stupnov sedi)
        
    public:
        MelEn_transform(int nmb) : max_log_val(-std::numeric_limits<double>::max()), coef(nmb), max_output_val(255) {}
        int make_picture(const char *input, const char *output);
	void clear_max_log();
        
    protected:
        int count_lines_find_max(ifstream & fIN);
        int scheme(float nmb);
        int num_length(int nmb);
	void check_max_log(float nmb);

};

#endif