/* 
 * autor: Kamil Behun
 * email: xbehun03@stud.fit.vutbr.cz 
 * popis: trieda Histogram
 *        je urcena k ukladaniu histogramu pre jeden MFCC 
 *   
 */

#ifndef _HISTOGRAM_H_
#define _HISTOGRAM_H_

#include <iostream>
#include <fstream>
#include <map>

using namespace std;

class Histogram {

    private:
        float max;              // maximalna hodnota intervalu histogramu
        float min;              // minimalna hodnota intervalu histogramu
        int secv;               // pocet dielcich intervalov histogramu
        map<int,double> hst;    // prislusne hodnoty histogramu pre jeho prislusne intervaly    
    
    public:
      Histogram(int n_secv, float maximum, float minimum);
      void insert(float num);
      void optimization(int opt);
      void clear(void);
      map<int,double> & get_hist(void);
      void concatenate_1(map<int,double> & h);
      void print_to_file(int begin, ofstream & fOUT);
      void vypis(void);
      void skuska(void);
      ~Histogram() {}

};

#endif