/* 
 * autor: Kamil Behun
 * email: xbehun03@stud.fit.vutbr.cz 
 * popis: trieda Mfcc_hist
 *        je urcena k ukladaniu histogramov jednotlivych MFCC zadaneho suboru 
 *   
 */

#ifndef _MFCC_HIST_H_
#define _MFCC_HIST_H_

#include <iostream>
#include <fstream>
#include <map>

#include "histogram.h"
#include "max_min.h"

using namespace std;

class Mfcc_hist {

    private:
       int num_segs;
       map<int, Histogram*> coef;   // jednotlive histogramy MFCC
    
    public:
       Mfcc_hist(Max_min & extr, int num_coef, int num_arr);
       map<int,double> & get_hist(unsigned int idex);
       int make_histograms(const char *file);
       void clear_histograms(void);
       void concatenate(Mfcc_hist & h);
       void print_to_file(int label,ofstream & fOUT);
       ~Mfcc_hist();
                     
};



#endif