#!/usr/bin/perl -w
# Autor: Kamil Behun
# skript urceny k vytvoreniu adresarovej struktury MFCC podla Datasetu pesniciek vo formate mp3

#######################################################################################################
# inicializacia globalnych premennych reprezentujicich vyskyt urcitych parametrov v prikazovom riadku #
#######################################################################################################
sub valueInit {
  $hlp = 0; $out = 0; $in = 0; $t = 0;
  $inAddr = ""; $outAddr = ""; $time = 0;
}

##############################################################################
# naplnenie premennych urcijucich vyskyt urciteho parametu prikazoveho radku #
# funkcia sluzi na rozparsovanie prikazoveho riadka                          #
##############################################################################
sub argvLoader {
  my $param = "";
  my $pouzitie = 0;
  my $j = 0;
  if (!defined @ARGV) {
     return 1;
  }
  for ($j = 0; $j <= $#ARGV; $j++) {
      $param = $ARGV[$j];
      #rocleneni a spocteni parametru
      SWITCH: {
            $param =~ /^-h$/o                     && do { $hlp++;
                                                   $pouzitie = 1;
                                                   last SWITCH; };
            $param =~ /^-t=(.*)$/o                && do { $t++;
                                                   $time = $1;
                                                   $pouzitie = 1;
                                                   last SWITCH; }; 
            $param =~ /^--inputAddr=(.*)$/o       && do { $in++;
                                                   $inAddr = $1;
                                                   $pouzitie = 1;
                                                   last SWITCH; };
            $param =~ /^--outputAddr=(.*)$/o    && do { $out++;
                                                   $outAddr = $1;
                                                   $pouzitie = 1;
                                                   last SWITCH; };
      }
      if ($pouzitie != 1) {
          return 0;
      }
      else {
      }
      $pouzitie = 0;
  }
  return 1;
}

######################################################################
# overenie spravnej syntaxie parametrov prikazoveho riadka           #
# nie kazdy parameter sa moze pouzit v kombinacii s inym             #
# tato funkcia overuje aj ci nedoslo k nasobnemu pouzitiu parametrov #
# vystupom je 0 pri chybe alebo 1 pri spravnom kontexte parametrov   # 
######################################################################
sub argvControler {
  if ($hlp != 0) {
     if ($hlp != 1) {
        return 0;
     }
     if (($in != 0) || ($out != 0) || ($t != 0)) {
        return 0;
     }
     else {
        return 1;
     }
  }
  if ($in != 0) {
     if ($in != 1) {
        return 0;
     }
  }
  else {
     $inAddr = "mp3";
  }
  if ($out != 0) {
     if ($out != 1) {
        return 0;
     }
  }
  else {
     $outAddr = "DataSet";
  }
  if ($t != 0) {
     if ($t != 1) {
        return 0;
     }
  }
  else {
     $time = "00.20";
  }
  
  return 1;
}

###########################
sub vypisParam {
  
  print "outAddr = " . $out ." ". $outAddr ."\n";
  print "inAddr = " . $in ." ". $inAddr ."\n";
  print "time = " . $t ." ". $time ."\n";

}

###############################################################
# vytvara offset pre jednotlive casti nasekanej pesnicky      #
# vdaka tomu je mozne hladat posledny usek nasekanej pesnicky #
###############################################################
sub retOffset {

    my($nmb) = @_;

    my $num = $nmb;
    my $cnt = 1;

    while ($num >= 10) {
	$num /= 10;
	$cnt++;
    }

    my $ret = "";

    for (my $i = 0; $i < 3 - $cnt; $i++) {
	$ret .= "0";
    }

    $ret .= $nmb;

    return $ret;
}

#########################################
# maze posledny usek nasekanej pesnicky #
#########################################
sub delteLastPart {

    my($baza) = @_;

    my $count = 1;
    my $delete_file = "";
    my $hlp = "";

    $delete_file = $baza . &retOffset($count) . ".mp3";

    for (my $i = 1; $i <= 999; $i++) {

	$hlp = $baza . &retOffset($count) . ".mp3";

	if (-f $hlp) {
	   $delete_file = $hlp;
	}
	else {
	   last;
	}
	$count++;
    }

    print "mazany subor je::::: " . $delete_file . "\n";

    unlink $delete_file;
}


########################################################################################################
# funkcia na nasekanie pesniciek vo formate mp3 na rovnake casove useky pomocou nastroja mp3splt       #
# rekurzivne prechadza vstupny adresar vyhladava pesnicky vo formate mp3, ktore nasekava               #
########################################################################################################
sub rozclenAdresar {

    my($dir,$out_dir) = @_;

    my $fh;
    my $adresa = "";
    my $vys = "";
    my $baza = "";
    my $mp3_subor = "";
    my $delete_part = "";
    
    opendir($fh, $dir) or die "Nepodarilo sa otevrit $dir: $!";
     
    while (my $pol = readdir $fh){
        next if $pol eq "." or $pol eq "..";
        
        $adresa = $dir . "/" . $pol;
        if (-f $adresa){
            if ($pol =~ /.*\.mp3$/o) {
                $mp3_subor = $adresa;
		$mp3_subor =~ s/([\~\!\@\#\$\%\^\&\*\(\)\{\}\[\]\"\'\`])/\\$1/g;
                $mp3_subor =~ s/ /\\ /g;
		$baza = $pol;
		$baza =~ s/([\~\!\@\#\$\%\^\&\*\(\)\{\}\[\]\"\'\`])//g;
                $baza =~ s/ //g;
		$baza =~ s/\.mp3$//;

                if ((system "mp3splt -f -t ". $time ." ". $mp3_subor ." -o ". $baza ."_\@n -d ". $out_dir) != 0) {
                    die "nepodarilo sa nasekat pesnicku: " . $mp3_subor . "\n";
                }

		$delete_part = $out_dir . "/" . $baza . "_";

		&delteLastPart($delete_part);

            }
        } elsif(-d $adresa){

            $vys = $out_dir . "/" . $pol;
            &rozclenAdresar($adresa,$vys);  #rekurzia
        }
    }
}


################## zaciatok skriptu ########################

$napoveda =
"Skript split_mp3 - nasekava pesnicky na rovnake urcene casove useky
Autor: Kamil Behun
Vyuzivane nastroje: mp3splt
- tento skript bol pouzity pre ucel bakalarskej prace

Skript slit_mp3 nasetava pesnicky, vo fomate mp3, vstupneho adresaru
pomocou mp3splt na zadane casove useky. Kedze posledny usek nasekanej
pesnicky nemava pozadovanu casovu dlzku, je odstranovany.

Rekurzivne sa zanoruje vo vstupnom adresary, kde vyhladava jednotlive
pesnicky vo formate mp3 a ich nasekane usek uklada do vystupneho adreasara,
v ktorom vytvara podobnu adresarovu strukturu ako je vo vstupnom adresari
a v zavislosti na tom aku poziciu ma nasekavana pesnicka uklada nasekane
useky vo vystupnom adresari.

Skript je mozne spustat s nasledujucimi parametrami:

    -h                  Napoveda

    -t=cas              Urcuje cas na aky maju byt pesnicky nasekane. Tento cas
                        je treba zadavat vo formate: minuty.sekundy
                        Napriklad: 00.10 znamena 10 sekund

    --inputAddr=meno    Tento parameter urcuje meno vstupneho adresara, ktoreho
                        pesnicky chceme nasekat.
                        Defaultne meno adresara je \"mp3\".

    --outputAddr=meno   Tento parameter urcuje meno vystupneho adresara, kde budu
                        nasekane useky pesnicky ukladane.
                        Defaultne meno je \"DataSet\".
";

&valueInit();

if (&argvLoader() == 0) {
    die "zle zadane parametre prikazoveho riadku\n"
}

if (&argvControler() == 0) {
    die "zle zadane parametre prikazoveho riadku, nasobne alebo nepovolene kombinacie paramatrov\n";
}

if ($hlp == 1) {
   print $napoveda;
} else {
   &vypisParam();
   &rozclenAdresar($inAddr,$outAddr);
   print "vsetko prebehlo OK\n";
}
